<?php

/**
 * certificacion actions.
 *
 * @package    nomina
 * @subpackage certificacion
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class certificacionActions extends sfQuery {

    /**
     * Se cambio a SQL por el filtro de area certif - 20210408
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");


        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by tipo_certificacion, descripcion';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $periodo = $request['id_periodo'];

            if (isset($request['id_periodo_filtro'])) {
                $periodo_filtro = $request['id_periodo_filtro'];
                $id_periodo = $periodo_filtro;
            } else {
                $id_periodo = $periodo;
            }

            /*
             * Variables opcionales
             */
            //id_certificacion
            if (isset($request['id_certificacion'])) {
                $whereCertificacion = " AND tab0.id_certificacion = " . $request['id_certificacion'];
            } else {
                $whereCertificacion = ' ';
            }
            //tipo_certificacion
            if (isset($request['tipo_certificacion'])) {
                $whereTipoCertificacion = " AND tab0.tipo_certificacion = " . $request['tipo_certificacion'];
            } else {
                $whereTipoCertificacion = ' ';
            }
            //estado
            if (isset($request['estado']) && $request['estado'] == 'true') {
                $whereEstado = " AND tab0.estado = 1 ";
            } else if (isset($request['estado']) && $request['estado'] == '1') {
                $whereEstado = " AND tab0.estado = 1 ";
            } else if (isset($request['estado']) && $request['estado'] == '0') {
                $whereEstado = " AND tab0.estado = 0 ";
            } else if (isset($request['estado']) && $request['estado'] == 'false') {
                $whereEstado = " AND tab0.estado IN (0,1)";
            } else {
                $whereEstado = ' ';
            }
            //aplica_usuario
            if (isset($request['aplica_usuario']) && $request['aplica_usuario'] == 'true') {
                $whereAplicaUsuario = " AND tab0.aplica_usuario = 1 ";
            } else if (isset($request['aplica_usuario']) && $request['aplica_usuario'] == '1') {
                $whereAplicaUsuario = " AND tab0.aplica_usuario = 1 ";
            } else if (isset($request['aplica_usuario']) && $request['aplica_usuario'] == '0') {
                $whereAplicaUsuario = " AND tab0.aplica_usuario = 0 ";
            } else if (isset($request['aplica_usuario']) && $request['aplica_usuario'] == 'false') {
                $whereAplicaUsuario = " AND tab0.aplica_usuario IN (0,1)";
            } else {
                $whereAplicaUsuario = ' ';
            }
            //aplica_docu_param
            if (isset($request['aplica_docu_param']) && $request['aplica_docu_param'] == 'true') {
                $whereAplicaParamDocu = " AND tab0.aplica_docu_param = 1 ";
            } else if (isset($request['aplica_docu_param']) && $request['aplica_docu_param'] == '1') {
                $whereAplicaParamDocu = " AND tab0.aplica_docu_param = 1 ";
            } else if (isset($request['aplica_docu_param']) && $request['aplica_docu_param'] == '0') {
                $whereAplicaParamDocu = " AND tab0.aplica_docu_param = 0 ";
            } else if (isset($request['aplica_docu_param']) && $request['aplica_docu_param'] == 'false') {
                $whereAplicaParamDocu = " AND tab0.aplica_docu_param IN (0,1)";
            } else {
                $whereAplicaParamDocu = ' ';
            }


            /**
             * Se genera filtro segun tabla de NO_AREA_CERTIFICACION - 20210408::LAVILA
             * Si viene filtro de funcionario, toma periodo_filtro o periodo 
             */
            $whereAreaCertif = "";
            if (isset($request['num_doc'])) {
                $num_doc = $request['num_doc'];

                //consulta area segun periodo
                $sql = <<<EOD
SELECT
aut.*
FROM no_estado_func_v aut

left join no_periodo_v per
on per.id_periodo = aut.periodo

where
aut.num_doc = '$num_doc'
and per.anho_mes <= ( SELECT anho_mes FROM no_periodo_v where id_periodo = $id_periodo )

order by
aut.id_anhos desc,
aut.id_meses desc
EOD;
                $record = CN_TABLE::executeSQL($sql);

                if (count($record) > 0) {

                    $id_area = $record[0]['id_ea'];

                    if (isset($request['tipo_certificacion'])) {
                        $tipo_certificacion = $request['tipo_certificacion'];

                        //consulta area por certif y tipo
                        $sql = <<<EOD
SELECT
to_char( wm_concat(areacert.id_certificacion) ) as tipos_cert
                                
FROM no_area_certificacion areacert

left join no_certificacion cert
on cert.id_certificacion = areacert.id_certificacion

where
id_area = $id_area
and cert.tipo_certificacion = $tipo_certificacion  
and areacert.estado = 1   
EOD;
                        $record = CN_TABLE::executeSQL($sql);

                        if (count($record) > 0 && $record[0]['tipos_cert'] != null) {
                            $whereAreaCertif = " and tab0.id_certificacion in (" . $record[0]['tipos_cert'] . ")";
                        }
                    }
                }
            }


            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (

select
tab0.*
from NO_CERTIFICACION_V  tab0
       
where 1 = 1                
$whereCertificacion
$whereTipoCertificacion
$whereEstado                    
$whereAplicaUsuario                    
$whereAreaCertif
$whereAplicaParamDocu                    
    
)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select
tab0.*
from NO_CERTIFICACION_V  tab0
     
where 1 = 1   
$whereCertificacion
$whereTipoCertificacion
$whereEstado                    
$whereAplicaUsuario   
$whereAreaCertif
$whereAplicaParamDocu                    
    
$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[certificacion] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'NO_CERTIFICACION_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'NO_CERTIFICACION_V' =>
        array(
            'id_certificacion' => 'id_certificacion',
            'tipo_certificacion' => 'tipo_certificacion',
            'op_tipo_certificacion' => 'op_tipo_certificacion',
            'comando' => 'comando',
            'descripcion' => 'descripcion',
            'aplica_usuario' => 'aplica_usuario',
            'estado' => 'estado',
            'empresa' => 'empresa',
            'prefijo' => 'prefijo',
            'aplica_docu_param' => 'aplica_docu_param'
        )
    ); //por cada tabla especificar los campos del select

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'NO_CERTIFICACION_V' => array(
            'id_certificacion,a' => array('!=' => array(-1)),
            'id_certificacion,b' => array('=' => array('id_certificacion')),
            'estado' => array('=' => array('estado')),
            'aplica_usuario' => array('=' => array('aplica_usuario')),
            'aplica_docu_param' => array('=' => array('aplica_docu_param')),
            'tipo_certificacion' => array('=' => array('tipo_certificacion')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(); // filtros de condicion or
//    protected $query_qualifier = 'DISTINCT'; //Variable para el sql para eliminar filas repetidas
    protected $fields_orderBy = array(
        'tipo_certificacion', 'descripcion'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Area';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;


    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_certificacion'; //identificador de la tabla
    protected $id_names = array('id_certificacion'); //llave primaria
    protected $field_names = array('tipo_certificacion', 'comando', 'descripcion', 'aplica_usuario',
        'estado', 'empresa', 'prefijo', 'aplica_docu_param'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'NO_CERTIFICACION'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = false; //si posee secuencia la tabla - true si es por tabla, false - trigger
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_certificacion'; //identificador unico de la tabla
    //false - Registrar log para list - consultar
    protected $log_list = false;
    //false - Registrar log para add - update - remove
    protected $log_crud = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    // Validate

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
